<?php
/**
 * Created by PhpStorm.
 * User: Admin
 * Date: 04.04.2017
 * Time: 8:10
 */
use NetworkPosts\Components\NetsPostsHtmlHelper;
use NetworkPosts\Components\Settings\NetsPostsNetworkSettings;
if ( ! defined( 'POST_VIEWS_PATH' ) ) {
	die();
}
$wrap_text_start = sanitize_quotes( $shortcode_mgr->get( 'wrap_text_start' ) );
$text_color = $shortcode_mgr->get( 'text_color' );
$auto_excerpt = $shortcode_mgr->get_boolean( 'auto_excerpt' );
$excerpt_length = $shortcode_mgr->get( 'excerpt_length' );
$excerpt_letters_length = $shortcode_mgr->get( 'excerpt_letters_length' );
$full_text = $shortcode_mgr->get_boolean( 'full_text' );
$manual_excerpt_length = $shortcode_mgr->get( 'manual_excerpt_length' );
$manual_excerpt_letters_length = $shortcode_mgr->get( 'manual_excerpt_letters_length' );
$use_shortcode_in_excerpt = $shortcode_mgr->get_boolean( 'use_shortcode_in_excerpt' );
$wrap_excerpt_start = sanitize_quotes( $shortcode_mgr->get( 'wrap_excerpt_start' ) );
$wrap_excerpt_end = $shortcode_mgr->get( 'wrap_excerpt_end' );
$wrap_text_end = $shortcode_mgr->get( 'wrap_text_end' );
$html .= htmlspecialchars_decode( $wrap_text_start );
$html .= '<div class="netsposts-excerpt" style="color: ' . $text_color . ';">';
if( $shortcode_mgr->has_value( 'strip_excerpt_tags' ) ) {
	$strip_excerpt_tags = $shortcode_mgr->get_boolean( 'strip_excerpt_tags' );
} else {
	$blog_id = get_current_blog_id();
	$strip_excerpt_tags = NetsPostsNetworkSettings::is_excerpt_tags_denied( $blog_id );
}
if( $strip_excerpt_tags ){
	$content = strip_tags( $the_post['post_content'] );
} else {
	$content = $the_post['post_content'];
}
if( $shortcode_mgr->get_boolean( 'filter_excerpt_shortcodes' ) &&
	! $use_shortcode_in_excerpt ){
	$content = strip_shortcodes( $content );
}
if ( $auto_excerpt || ! $the_post['post_excerpt'] ) {
	if( $the_post['post_content'] ) {
		if ( $excerpt_length ) {
			$excerpt = get_words_excerpt( $excerpt_length, $content, $the_post['guid'] );
		} else if ( $excerpt_letters_length ) {
			$excerpt = ShortenText( $content, $excerpt_letters_length );
		}
	} else {
		$excerpt = '';
	}
} else {
	$excerpt = $the_post['post_excerpt'];
}
if ( $use_shortcode_in_excerpt ) {
	if ( $excerpt ) {
		$excerpt = do_shortcode( $excerpt );
	}
}
if ( $shortcode_mgr->get_boolean( 'filter_excerpt' ) ) {
	if ( $excerpt ) {
		$excerpt = apply_filters( 'the_excerpt', $excerpt );
	}
}
if ( $full_text ) {
	$text = $the_post['post_content'];
	$text = do_shortcode( $text );
	$text = netsposts_remove_pagination( $text );
} else {
	if( $strip_excerpt_tags ){
		$post_excerpt = strip_tags( $the_post['post_excerpt'] );
	} else {
		$post_excerpt = $the_post['post_excerpt'];
	}
	if ( $manual_excerpt_length ) {
		$text = get_words_excerpt( $manual_excerpt_length, $post_excerpt, $the_post['guid'] );
	} else if ( $manual_excerpt_letters_length ) {
		$text = ShortenText( $post_excerpt, $manual_excerpt_letters_length );
	} else {
		$text = $excerpt;
	}
}
if ( ! $shortcode_mgr->get_boolean( 'hide_excerpt' ) ) {
	$domain_url = get_site_url();
	$parent_blog_url = get_site_url( 1 );
	if( !$use_single_images_folder ){
		$text = netsposts_replace_image_domains( $text, $parent_blog_url, $domain_url );
		$text = netsposts_replace_image_link_domains( $text, $parent_blog_url, $domain_url );
	}
	$html .= htmlspecialchars_decode( $wrap_excerpt_start );
	$html .= strip_shortcodes( $text );
	$html .= htmlspecialchars_decode( $wrap_excerpt_end );
}
$show_link = true;
$pages_without_readmore_link = array();
$show_link = empty( $hide_all_links );
if ( $show_link ) {
	$title = $the_post['post_title'];
	if ( ! empty( $pages_string ) > 0 ) {
		$pages_without_readmore_link = explode( ';', $pages_string );
		foreach ( $pages_without_readmore_link as $item ) {
			if ( trim( strtolower( $title ) ) == trim( strtolower( $item ) ) ) {
				$show_link = false;
			}
		}
	}
}
if( $shortcode_mgr->has_value( 'exclude_read_more_link' ) ) {
	if ( $shortcode_mgr->get_boolean( 'exclude_read_more_link' ) ) {
		$show_link = false;
	} else {
		$exclude_read_more_link = $shortcode_mgr->split_array( 'exclude_read_more_link', ',' );
		$show_link              = ! in_array( $the_post['ID'], $exclude_read_more_link );
	}
}
if ( $show_link ) {
	if( $shortcode_mgr->has_value( 'read_more_text' ) ){
		$link_text = $shortcode_mgr->get( 'read_more_text' );
	}
	else{
		$link_text = __( 'read more', 'netsposts' ) . '&nbsp;&#10095;';
	}
	$html .= NetsPostsHtmlHelper::create_link( $the_post['guid'],
		$link_text,
		$open_link_in_new_tab,
		'netsposts-read-more-link'
	);
}
$html .= '</div>';//end of netsposts-excerpt
$html .= htmlspecialchars_decode( $wrap_text_end );